package edu.uiuc.ncsa.security.oauth_1_0a.server;

import edu.uiuc.ncsa.security.delegation.server.request.ATRequest;
import edu.uiuc.ncsa.security.delegation.storage.Client;

import javax.servlet.http.HttpServletRequest;

/**
 * This is an OAuth 1.0a specific form of the request which requires the verifier.
 * This is needed since the basic delegation service
 * is actually based on the OAuth 2.0 redirection flow, i.e., OAuth 1 requires that a verifier be sent, but
 * OAuth 2 does not.
 * <p>Created by Jeff Gaynor<br>
 * on 9/21/11 at  12:52 PM
 */
public class OAuthATRequest extends ATRequest {

    public OAuthATRequest(HttpServletRequest client, Client servletRequest) {
        super(client, servletRequest);
    }

}
